#include "stdafx.h"
#include "NotifyWindowItem.h"
#include "UpdaterDocument.h"
#include "Application.h"
#include "Registry.h"
#include "AgentDLL.h"
#include "../../../Common/CoreValueManager.h"

BOOL UpdaterNotifyWindowItem::CheckShowStartPage(tipupdater::UpdaterDocument *doc)
{
	if( doc->GetUpdaterConfigModel()->IsUseCheckCoreValue() == FALSE )
		return FALSE;

	CoreValueManager coreValue;
	CString start_page = doc->GetUpdaterCommonModel()->GetStartPageURL();
	return !coreValue.IsNaverStartPage(start_page);
}

BOOL UpdaterNotifyWindowItem::CheckShowDefaultSearch(tipupdater::UpdaterDocument *doc)
{
	if( doc->GetUpdaterConfigModel()->IsUseCheckCoreValue() == FALSE )
		return FALSE;

	CoreValueManager coreValue;
	if (!coreValue.IsIEVersion70())
		FALSE;

	CString clsid = doc->GetUpdaterCommonModel()->GetDefaultSearchCLSID();
	CString url = doc->GetUpdaterCommonModel()->GetDefaultSearchURL();

	return !coreValue.IsNaverDefaultSearch(clsid,url);
}

BOOL UpdaterNotifyWindowItem::CheckShowUpgrade(tipupdater::UpdaterDocument *doc)
{
	if( doc->GetUpdaterConfigModel()->IsUseNotifyUpdate() == FALSE )
		return FALSE;

	CoreValueManager coreValue;

	AgentDLLWrapper* agentDllWrapper = AgentDLLManager::Find(m_guid);
	if( NULL == agentDllWrapper )
		return FALSE;

	NAVERAPP_INSTALL_STATUS InstallStatus;
	agentDllWrapper->GetInstalledStatus(InstallStatus);

	BOOL ret = FALSE;
	switch(InstallStatus)
	{
	case NotInstalled:
		// ̼ġ ˸ ϴ ̹ ٸ ϵ Ѵ.
		if(CString(L"39B419B3-D960-46b2-97CB-82F5BD61799B").CompareNoCase(m_guid) == 0 )
		{
			ret = TRUE;
		}
		break;

	case OldVersion:
		ret = TRUE;
		break;
	default:
		break;
	}

	AgentDLLManager::Unregister(agentDllWrapper);
	return ret;
}

BOOL UpdaterNotifyWindowItem::CheckShowNotifyWindow(tipupdater::UpdaterDocument *doc)
{
	switch( m_NotifyType )
	{
	case TYPE_NOTINSTALLED_PROGRAM:
	case TYPE_UPGRADE_PROGRAM:
		return CheckShowUpgrade(doc);

	case TYPE_CHANGE_STARTPAGE:
		return CheckShowStartPage(doc);

	case TYPE_CHANGE_DEFAULTSEARCH:
		return CheckShowDefaultSearch(doc);

	default:
		return FALSE;
	}

	return TRUE;
}

void UpdaterNotifyWindowItem::BindDataContext( CString &layout, SimpleMapDataContext *dataContext, tipupdater::UpdaterDocument *doc )
{
	switch( m_NotifyType )
	{
	case TYPE_UPGRADE_PROGRAM:
		layout = Application::LoadString(_T("IDS_NOTIFYWINDOW_LAYOUT_UPDATE"));
		break;

	case TYPE_NOTINSTALLED_PROGRAM:
		layout = Application::LoadString(_T("tip_notifywindow_notinstalled"));
		break;

	case TYPE_CHANGE_STARTPAGE:
		layout = Application::LoadString(_T("IDS_NOTIFYWINDOW_LAYOUT_SP"));
		return;

	case TYPE_CHANGE_DEFAULTSEARCH:
		layout = Application::LoadString(_T("IDS_NOTIFYWINDOW_LAYOUT_DS"));
		return;

	default:
		layout = _T("");
		return;
	}

	TipServiceData* service = doc->SearchService(m_guid);
	if( NULL == service || NULL == dataContext )
	{
		layout = _T("");
		return;
	}


	dataContext->Add(_T("service"), service->GetDataContext());
 	CString text = dataContext->GetProperty(_T("service.(update.copy)"));
 	if( text.GetLength() > 15 )
 	{
 		text.SetAt(15, 0);
 		text.SetAt(14, '.');
 		text.SetAt(13, '.');
 		text.SetAt(12, '.');
 
 		CComVariant strText = text;
 		dataContext->SetProperty(_T("service.(update.copy)"), strText);
 	}
}